public class Orientation {

	public void formOrange(Rubik rubik) {
		rubik.rotationHoraire(Couleur.Bleu);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Bleu);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Bleu);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Bleu);
	}
	
	public void formBleu(Rubik rubik) {
		rubik.rotationHoraire(Couleur.Rouge);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Rouge);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Rouge);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Rouge);
	}
	
	public void formRouge(Rubik rubik) {
		rubik.rotationHoraire(Couleur.Vert);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Vert);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Vert);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Vert);
	}
	
	public void formVert(Rubik rubik) {
		rubik.rotationHoraire(Couleur.Orange);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Orange);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationHoraire(Couleur.Orange);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(Couleur.Orange);
	}
	
	public boolean finishOrange(Rubik rubik) {
	return (rubik.orange.arrete1.couleur == Couleur.Orange && 
			rubik.bleu.arrete2.couleur != Couleur.Bleu && 
			rubik.rouge.arrete3.couleur != Couleur.Rouge &&
			rubik.vert.arrete4.couleur != Couleur.Vert);
	}
	
	public boolean finishBleu(Rubik rubik) {
	return (rubik.orange.arrete1.couleur != Couleur.Orange && 
			rubik.bleu.arrete2.couleur == Couleur.Bleu && 
			rubik.rouge.arrete3.couleur != Couleur.Rouge &&
			rubik.vert.arrete4.couleur != Couleur.Vert);
	}
	
	public boolean finishRouge(Rubik rubik) {
	return (rubik.orange.arrete1.couleur != Couleur.Orange && 
			rubik.bleu.arrete2.couleur != Couleur.Bleu && 
			rubik.rouge.arrete3.couleur == Couleur.Rouge &&
			rubik.vert.arrete4.couleur != Couleur.Vert);
	}
	
	public boolean finishVert(Rubik rubik) {
	return (rubik.orange.arrete1.couleur != Couleur.Orange && 
			rubik.bleu.arrete2.couleur != Couleur.Bleu && 
			rubik.rouge.arrete3.couleur != Couleur.Rouge &&
			rubik.vert.arrete4.couleur == Couleur.Vert);
	}
	
	public boolean finish(Rubik rubik) {
	return (rubik.orange.arrete1.couleur == Couleur.Orange && 
			rubik.bleu.arrete2.couleur == Couleur.Bleu && 
			rubik.rouge.arrete3.couleur == Couleur.Rouge &&
			rubik.vert.arrete4.couleur == Couleur.Vert);
	}
	
	public boolean dernierCas(Rubik rubik) {
	return ((rubik.orange.arrete1.couleur == Couleur.Orange && rubik.rouge.arrete3.couleur == Couleur.Rouge) 
			|| (rubik.bleu.arrete2.couleur == Couleur.Bleu && rubik.vert.arrete4.couleur == Couleur.Vert));
	}
	
	
	public void solve(Rubik rubik) {
		while (!finishOrange(rubik) && !finishRouge(rubik) && !finishBleu(rubik) && !finishVert(rubik) && !finish(rubik))
			{
				rubik.rotationHoraire(Couleur.Jaune);
				if (dernierCas(rubik))
					{
						formOrange(rubik);
					}
			}
			
		if (finishOrange(rubik))
			{
				while (!finish(rubik))
					{
						formOrange(rubik);
					}
			}
		
		if (finishBleu(rubik))
			{
				while (!finish(rubik))
					{
						formBleu(rubik);
					}
			}
			
		if (finishRouge(rubik))
			{
				while (!finish(rubik))
					{
						formRouge(rubik);
					}
			}

		if (finishVert(rubik))
			{
				while (!finish(rubik))
					{
						formVert(rubik);
					}
			}
	}
	
	public void test(Rubik rubik, String m) {
		if (finish(rubik))
			{
				System.out.println("Orientation Terminer (" + m+")");
			}
		else
			{
				System.out.println("Orientation Fail (" + m+")");
			}
		}
	
}