import java.util.ArrayList;

public class Rubik implements Cloneable {
	public Face blanc;
	public Face bleu;
	public Face rouge;
	public Face orange;
	public Face vert;
	public Face jaune;
	
	public ArrayList<String> list;

//////////////////////////////////////////////////////////////////////////////////////	
//			Patron de Rubik's cube referent 			    //
//////////////////////////////////////////////////////////////////////////////////////
// 										    //
//  		            1 | 1  | 2						    //
// 		            4 | o  | 2						    //
// 		            4 | 3  | 3						    //
//		1 | 1 | 2 | 1 | 1  | 2 | 1 | 1  | 2 | 1 | 1 | 2 		    //
// 		4 | v | 2 | 4 | bc | 2 | 4 | bl | 2 | 4 | j | 2  		    //
// 		4 | 3 | 3 | 4 | 3  | 3 | 4 | 3  | 3 | 4 | 3 | 3 		    //
//   		            1 | 1  | 2 						    //
//     		            4 | r  | 2 						    //
//     		            4 | 3  | 3 						    //
// 										    //		
//////////////////////////////////////////////////////////////////////////////////////

    public Rubik clone(){  
		Rubik rubik = new Rubik();
		rubik.blanc = blanc.clone();
		rubik.bleu = bleu.clone();
		rubik.rouge = rouge.clone();
		rubik.orange = orange.clone();
		rubik.vert = vert.clone();
		rubik.jaune = jaune.clone();
		rubik.lierCube();
	return rubik;
    }

	public Rubik() {
	//Création des faces
		blanc   = new Face(Couleur.Blanc);
		bleu    = new Face(Couleur.Bleu);
		rouge   = new Face(Couleur.Rouge);
		orange  = new Face(Couleur.Orange);
		vert    = new Face(Couleur.Vert);
		jaune   = new Face(Couleur.Jaune);	
		
		lierCube();
		
		list = new ArrayList<String>();
		}
		
	public void lierCube()
		{
		//blanc
		blanc.coin1.coinAdj1 = vert.coin2;
		blanc.coin1.coinAdj2 = orange.coin4;
		blanc.coin2.coinAdj1 = orange.coin3;
		blanc.coin2.coinAdj2 = bleu.coin1;
		blanc.coin3.coinAdj1 = bleu.coin4;
		blanc.coin3.coinAdj2 = rouge.coin2;
		blanc.coin4.coinAdj1 = rouge.coin1;
		blanc.coin4.coinAdj2 = vert.coin3;

		blanc.arrete1.arreteAdj = orange.arrete3;
		blanc.arrete2.arreteAdj = bleu.arrete4;
		blanc.arrete3.arreteAdj = rouge.arrete1;
		blanc.arrete4.arreteAdj = vert.arrete2;

		//rouge
		rouge.coin1.coinAdj1 = vert.coin3;
		rouge.coin1.coinAdj2 = blanc.coin4;
		rouge.coin2.coinAdj1 = blanc.coin3;
		rouge.coin2.coinAdj2 = bleu.coin4;
		rouge.coin3.coinAdj1 = bleu.coin3;
		rouge.coin3.coinAdj2 = jaune.coin4;
		rouge.coin4.coinAdj1 = jaune.coin3;
		rouge.coin4.coinAdj2 = vert.coin4;

		rouge.arrete1.arreteAdj = blanc.arrete3;
		rouge.arrete2.arreteAdj = bleu.arrete3;
		rouge.arrete3.arreteAdj = jaune.arrete3;
		rouge.arrete4.arreteAdj = vert.arrete3;

		//bleu
		bleu.coin1.coinAdj1 = blanc.coin2;
		bleu.coin1.coinAdj2 = orange.coin3;
		bleu.coin2.coinAdj1 = orange.coin2;
		bleu.coin2.coinAdj2 = jaune.coin1;
		bleu.coin3.coinAdj1 = jaune.coin4;
		bleu.coin3.coinAdj2 = rouge.coin3;
		bleu.coin4.coinAdj1 = rouge.coin2;
		bleu.coin4.coinAdj2 = blanc.coin3;

		bleu.arrete1.arreteAdj = orange.arrete2;
		bleu.arrete2.arreteAdj = jaune.arrete4;
		bleu.arrete3.arreteAdj = rouge.arrete2;
		bleu.arrete4.arreteAdj = blanc.arrete2;

		//orange
		orange.coin1.coinAdj1 = vert.coin1;
		orange.coin1.coinAdj2 = jaune.coin2;
		orange.coin2.coinAdj1 = jaune.coin1;
		orange.coin2.coinAdj2 = bleu.coin2;
		orange.coin3.coinAdj1 = bleu.coin1;
		orange.coin3.coinAdj2 = blanc.coin2;
		orange.coin4.coinAdj1 = blanc.coin1;
		orange.coin4.coinAdj2 = vert.coin2;

		orange.arrete1.arreteAdj = jaune.arrete1;
		orange.arrete2.arreteAdj = bleu.arrete1;
		orange.arrete3.arreteAdj = blanc.arrete1;
		orange.arrete4.arreteAdj = vert.arrete1;

		//jaune
		jaune.coin1.coinAdj1 = bleu.coin2;
		jaune.coin1.coinAdj2 = orange.coin2;
		jaune.coin2.coinAdj1 = orange.coin1;
		jaune.coin2.coinAdj2 = vert.coin1;
		jaune.coin3.coinAdj1 = vert.coin4;
		jaune.coin3.coinAdj2 = rouge.coin4;
		jaune.coin4.coinAdj1 = rouge.coin3;
		jaune.coin4.coinAdj2 = bleu.coin3;

		jaune.arrete1.arreteAdj = orange.arrete1;
		jaune.arrete2.arreteAdj = vert.arrete4;
		jaune.arrete3.arreteAdj = rouge.arrete3;
		jaune.arrete4.arreteAdj = bleu.arrete2;

		//vert
		vert.coin1.coinAdj1 = jaune.coin2;
		vert.coin1.coinAdj2 = orange.coin1;
		vert.coin2.coinAdj1 = orange.coin4;
		vert.coin2.coinAdj2 = blanc.coin1;
		vert.coin3.coinAdj1 = blanc.coin4;
		vert.coin3.coinAdj2 = rouge.coin1;
		vert.coin4.coinAdj1 = rouge.coin4;
		vert.coin4.coinAdj2 = jaune.coin3;

		vert.arrete1.arreteAdj = orange.arrete4;
		vert.arrete2.arreteAdj = blanc.arrete4;
		vert.arrete3.arreteAdj = rouge.arrete4;
		vert.arrete4.arreteAdj = jaune.arrete2;
		}
	
	public Face getFace(Couleur couleur_Face)
			{ 
				Face face = blanc ; 
		
				switch (couleur_Face)
					{
					case Bleu   : face = bleu ;
						break;
					case Rouge  : face = rouge ;
						break;
					case Vert   : face = vert ;
						break;
					case Orange : face = orange ;
						break;
					case Jaune  : face = jaune ;
						break;
					};
			return face;
			}

	public String rot(Couleur c)
	{
		String s ="";
		switch (c)
			{
				case Bleu :  s="Bleu";
					break;
				case Orange :   s="Orange";
					break;
				case Rouge :   s="Rouge";
					break;
				case Vert :   s="Vert";
					break;
				case Blanc :   s="Blanc";
					break;
				case Jaune :   s="Jaune";
					break;
			};
		return s;
	}

	public void rotationHoraire(Couleur couleur_Face) {
		list.add(rot(couleur_Face));
		
		Face face = getFace(couleur_Face); 
		//Rotation de la courrone
		
			//rotation des coins
			Couleur tmp1 = face.coin1.coinAdj1.couleur;
			Couleur tmp2 = face.coin1.coinAdj2.couleur;
			
			face.coin1.coinAdj1.couleur = face.coin4.coinAdj1.couleur;
			face.coin1.coinAdj2.couleur = face.coin4.coinAdj2.couleur;
			face.coin4.coinAdj1.couleur = face.coin3.coinAdj1.couleur;
			face.coin4.coinAdj2.couleur = face.coin3.coinAdj2.couleur;
			face.coin3.coinAdj1.couleur = face.coin2.coinAdj1.couleur;
			face.coin3.coinAdj2.couleur = face.coin2.coinAdj2.couleur;
			face.coin2.coinAdj1.couleur = tmp1;
			face.coin2.coinAdj2.couleur = tmp2;

		
		
			//rotation des arretes
			Couleur tmp3 = face.arrete1.arreteAdj.couleur;
			
			face.arrete1.arreteAdj.couleur = face.arrete4.arreteAdj.couleur;
			face.arrete4.arreteAdj.couleur = face.arrete3.arreteAdj.couleur;
			face.arrete3.arreteAdj.couleur = face.arrete2.arreteAdj.couleur;
			face.arrete2.arreteAdj.couleur = tmp3;
		
			
		//Rotation de la face
			
			//rotation des coins
			Couleur tmpc = face.coin1.couleur;
			
			face.coin1.couleur = face.coin4.couleur;
			face.coin4.couleur = face.coin3.couleur;
			face.coin3.couleur = face.coin2.couleur;
			face.coin2.couleur = tmpc;
		
			//rotation des arretes
			Couleur tmpa = face.arrete1.couleur;
			
			face.arrete1.couleur = face.arrete4.couleur;
			face.arrete4.couleur = face.arrete3.couleur;
			face.arrete3.couleur = face.arrete2.couleur;
			face.arrete2.couleur = tmpa;	
		
			}


	public void rotationAntiHoraire(Couleur couleur_Face) {
		list.add("a" +rot(couleur_Face));
		
		Face face = getFace(couleur_Face); 
			
		//Rotation de la courrone
			
			//rotation des coins
			Couleur tmp1 = face.coin1.coinAdj1.couleur;
			Couleur tmp2 = face.coin1.coinAdj2.couleur;
			
			face.coin1.coinAdj1.couleur = face.coin2.coinAdj1.couleur;
			face.coin1.coinAdj2.couleur = face.coin2.coinAdj2.couleur;
			face.coin2.coinAdj1.couleur = face.coin3.coinAdj1.couleur;
			face.coin2.coinAdj2.couleur = face.coin3.coinAdj2.couleur;
			face.coin3.coinAdj1.couleur = face.coin4.coinAdj1.couleur;
			face.coin3.coinAdj2.couleur = face.coin4.coinAdj2.couleur;
			face.coin4.coinAdj1.couleur = tmp1;
			face.coin4.coinAdj2.couleur = tmp2;
		
			//rotation des arretes
			Couleur tmp3 = face.arrete1.arreteAdj.couleur;
			
			face.arrete1.arreteAdj.couleur = face.arrete2.arreteAdj.couleur;
			face.arrete2.arreteAdj.couleur = face.arrete3.arreteAdj.couleur;
			face.arrete3.arreteAdj.couleur = face.arrete4.arreteAdj.couleur;
			face.arrete4.arreteAdj.couleur = tmp3;
			

		//Rotation de la face
			
			//rotation des coins
			Couleur tmpc = face.coin1.couleur;
			
			face.coin1.couleur = face.coin2.couleur;
			face.coin2.couleur = face.coin3.couleur;
			face.coin3.couleur = face.coin4.couleur;
			face.coin4.couleur = tmpc;
		
			//rotation des arretes
			Couleur tmpa = face.arrete1.couleur;
			
			face.arrete1.couleur = face.arrete2.couleur;
			face.arrete2.couleur = face.arrete3.couleur;
			face.arrete3.couleur = face.arrete4.couleur;
			face.arrete4.couleur = tmpa;
		
			}

	public void afficherTERM() {
		System.out.println("");
		System.out.println("");
		orange.afficherFace();
		System.out.println("");
		vert.afficherFace();
		System.out.println("");
		blanc.afficherFace();
		System.out.println("");
		bleu.afficherFace();
		System.out.println("");
		jaune.afficherFace();
		System.out.println("");
		rouge.afficherFace();
		System.out.println("");
			}
			
	public void melange() {
		int tour = 30;
		int rand = 0;
		while (tour != 0)
			{
				rand = (int)(Math.random() * 12.0);
				//System.out.print("Rand = " + rand + "   ");
				switch (rand % 11)
					{
						case 0 :  rotationHoraire(Couleur.Blanc);
							break;
						case 1 :  rotationHoraire(Couleur.Orange);
							break;
						case 2 :  rotationHoraire(Couleur.Vert);
							break;
						case 3 :  rotationHoraire(Couleur.Bleu);
							break;
						case 4 :  rotationHoraire(Couleur.Rouge);
							break;
						case 5 :  rotationHoraire(Couleur.Jaune);
							break;
						case 6 :  rotationAntiHoraire(Couleur.Blanc);
							break;
						case 7 :  rotationAntiHoraire(Couleur.Orange);
							break;
						case 8 :  rotationAntiHoraire(Couleur.Vert);
							break;
						case 9 :  rotationAntiHoraire(Couleur.Bleu);
							break;
						case 10 :  rotationAntiHoraire(Couleur.Rouge);
							break;
						case 11 :  rotationAntiHoraire(Couleur.Jaune);
							break;
					};
				tour--;
			}
		
			}




  }
